#include "AVL_structures.h"
#include <stdio.h>
#include <stdlib.h>

#ifndef _h_avl_functions
#define _h_avl_functions

	#define _def_failure	0
	#define _def_success	1

	extern avl_node_t *createNodeWithKey(avl_key_t key);
	extern avl_node_t *createNode();

	extern void displayTree(avl_node_t *tree);

	extern avl_node_t *insertNode(avl_node_t **root, avl_node_t *node);

	extern avl_node_t *link_node;

	extern void rotateNodeLeft(avl_node_t **root, avl_node_t *node);
	extern void rotateNodeRight(avl_node_t **root, avl_node_t *node);

	extern void rebalanceLeftSubtree(avl_node_t **root, avl_node_t *node);
	extern void rebalanceRightSubtree(avl_node_t **root, avl_node_t *node);

	extern char checkTree(avl_node_t *tree);
	extern void countNodes(avl_node_t *tree, unsigned int *node_c);

#endif
