#include "AVL_functions.h"

	static unsigned int* link_pointer = 0;
	
	avl_node_t *insertNode(avl_node_t **root, avl_node_t *node) {
		if(!node) { return (avl_node_t*)_def_failure;
		} else {
			avl_node_t *sentinel = (avl_node_t*)*root;

			if(!sentinel) {
				*root = node;
				return (avl_node_t*)_def_success;
			} else {
				while(1) {
					if(node->key < sentinel->key) {
						if(sentinel->left) sentinel = sentinel->left;
						else {
							node->parent = sentinel;
							link_pointer = (unsigned int*)&sentinel->left;
							break;
						}
					} else if(node->key > sentinel->key) {
						if(sentinel->right) sentinel = sentinel->right;
						else {
							node->parent = sentinel;
							link_pointer = (unsigned int*)&sentinel->right;
							break;
						}
					} else if(node->key == sentinel->key) {
						free(node);
						return _def_failure;
					}
				}

				*link_pointer = (unsigned int)node;

				while(1) {
					if(sentinel->left == node) sentinel->balance -= 1;
					else if(sentinel->right == node) sentinel->balance += 1;

					
					if(sentinel->balance < -1) { 
						rebalanceLeftSubtree(root, sentinel);
						break;
					} else if(sentinel->balance > 1) {
						rebalanceRightSubtree(root, sentinel);
						break;
					} else if(sentinel->balance == 0) break;
					
					if(sentinel->parent == 0) break;
					else {
						node = sentinel;
						sentinel = sentinel->parent;
					}
				}

				return node;
			}
		}
	}
