/******************************************************************************
** 									     **
**    Learnin' : AVL Self-balancing Binary search tree.			     **
**  ---------------------------------------------			     **
**									     **
**    Source: avl_main.c						     **
**   									     **
**    Purpose:								     **
**	To learn about the AVL data structure, to implement and go where     **
**	I have never beeeeen befooreeee! (Iterative AVL tree)		     **
**									     **
**    Author: DG.Ward.							     **
**									     **
**    Contact:								     **
**	comeherenightmare@hotmail.com					     **
**      warddg1@tekotago.ac.nz						     **
**	kyretzn@gmail.com						     **
**									     **
**    Date: 18th, March 2007						     **
**									     **
******************************************************************************/
#include "AVL_functions.h"

	#define _def_test_range	0x4000

        // --- main
        // *
        // *  purpose:
        // *  parameters:
        // *  returns:
        // *
        // ---
        int main(void) {
		avl_node_t *tree = 0;

		printf("ZCApp :: Conceptual AVL Implementation\r\n");
		printf("=======================================================\r\n");
		printf("Tree Listing:\r\n");

		unsigned int node_in = 0;

		for(unsigned int a = 0; a < _def_test_range; a++) {
			if(insertNode(&tree, createNodeWithKey(rand()%(_def_test_range * 2)))!=_def_failure) node_in++;
		}
		displayTree(tree);

		printf("Checking Tree integrity ... ");
		if(checkTree(tree) != _def_success) {
			printf("Tree broken.\r\n");
		} else printf("Tree ok.\r\n");

		printf("Tree statistics:\r\n");
		printf(" - Node's inserted: %d\r\n", node_in);
		unsigned int node_count = 0;
		countNodes(tree, &node_count);

		printf(" - Node's counted: %d\r\n", node_count);

                return 0;
        }
